\documentclass[a4paper,10pt]{article}

\renewcommand*{\tablename}{\small\textbf{Table}}
\renewcommand*{\figurename}{\small\textbf{Figure}}
\renewcommand*{\abstractname}{\small\textbf{Abstract}}

\begin{document}

\title{\textbf{Floppy Disks Controller}}
\author{Pawel Dziepak}
\date{\textit{July 25, 2008}}
\maketitle

\section{FDC driver overview}
\paragraph{}FDC is one of the devices that can be described as basic. In this case it means
that it is accessible directly from I/O ports. Motherboard's firmware emulates
all needed FDC ports independently from the bus that FDC is connected to. This
makes it very easy to get access to the device before any other drivers
(especially bus drivers) are initialized.
\paragraph{}FDC uses two modes of data transmission. The recommended one is using DMA and
transmitting data without any action of CPU (it just has to set everything
before transmission begins). The second, highly not recommended one is PIO,
using CPU to read/write bytes directly from I/O ports. This method produces
huge CPU load and is significantly slower.

\section{Registers}
to be completed

\section{Orders}

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{00110} \\
& 5 & SK \\
& 6 & MFM mode \\
& 7 & MT \\
\textbf{command1} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0 & US0 \\
& 1 & US1 \\
& 2 & HD \\
& 3-7 & reserved \\
\textbf{command2} & & cylinder number \\
\textbf{command3} & & head number \\
\textbf{command4} & & sector number \\
\textbf{command5} & & bytes per sector \\
\textbf{command6} & & end of track \\
\textbf{command7} & & gap 3 length \\
\textbf{command8} & & data length \\
\textbf{result0} & & sr0 \\
\textbf{result1} & & sr1 \\
\textbf{result2} & & sr2 \\
\textbf{result3} & & cylinder number \\
\textbf{result4} & & head number \\
\textbf{result5} & & sector number \\
\textbf{result6} & & bytes per sector
\end{tabular}
\caption{Read data from disk (\texttt{00110})}
\label{read}
\end{table} 

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{00101} \\
& 5 & always 0 \\
& 6 & MFM mode \\
& 7 & MT \\
\textbf{command1} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0 & US0 \\
& 1 & US1 \\
& 2 & HD \\
& 3-7 & reserved \\
\textbf{command2} & & cylinder number \\
\textbf{command3} & & head number \\
\textbf{command4} & & sector number \\
\textbf{command5} & & bytes per sector \\
\textbf{command6} & & end of track \\
\textbf{command7} & & gap 3 length \\
\textbf{command8} & & data length \\
\textbf{result0} & & sr0 \\
\textbf{result1} & & sr1 \\
\textbf{result2} & & sr2 \\
\textbf{result3} & & cylinder number \\
\textbf{result4} & & head number \\
\textbf{result5} & & sector number \\
\textbf{result6} & & bytes per sector
\end{tabular}
\caption{Write data to disk (\texttt{00101})}
\label{write}
\end{table} 

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{00111} \\
& 5-7 & reserved \\
\textbf{command1} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0 & US0 \\
& 1 & US1 \\
& 2 & HD \\
& 3-7 & reserved
\end{tabular}
\caption{Recalibrate (\texttt{00111})}
\label{recalibrate}
\end{table} 

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{01000} \\
& 5-7 & reserved \\
\textbf{result0} & & sr0 \\
\textbf{result1} & & cylinder number
\end{tabular}
\caption{Sense interrupt status (\texttt{01000})}
\label{senseint}
\end{table} 

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{00011} \\
& 5-7 & reserved \\
\textbf{command1} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-3 & head unload time (16 to 240ms in 16ms increments) \\
& 4-7 & step rate time (1 to 16ms in 1ms increments) \\
\textbf{command2} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0 & non-DMA mode \\
& 1-7 & head load time (2 to 254ms in 2ms increments)
\end{tabular}
\caption{Set head and step load rate (\texttt{00011})}
\label{sethead}
\end{table} 

\begin{table}
\begin{tabular}{lll}
\textbf{command0} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0-4 & order signature \texttt{01111} \\
& 5-7 & reserved \\
\textbf{command1} & & \\
& \textbf{bit} & \textbf{meaning} \\
& 0 & US0 \\
& 1 & US1 \\
& 2 & HD \\
& 3-7 & reserved \\
\textbf{command2} & & new cylinder number \\
\end{tabular}
\caption{Seek (\texttt{01111})}
\label{seek}
\end{table} 

\section{Credits}
\paragraph{}Based on document by unknown author, published at url:
\texttt{http://www.nondot.org/sabre/os/files/Disk/FLOPPY.TXT}

\end{document}
